#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "fontgen.h"

char buffer[100000];

#define WRITEF(...) {							\
    sprintf(buffer,__VA_ARGS__);					\
    write (1,buffer,strlen(buffer));					\
  }


void op_point(pl_point * point){
  WRITEF("\tOCT\t%06o\t",point->p_data);
  //  if (point->p_lift) WRITEF("LIFT PEN, ");
  //else  WRITEF("          ");  
  //WRITEF("MOVE TO (%i,%i)",point->p_x,point->p_y);
  WRITEF("\n");
}

void op_glyph( pl_glyph * glyph){
  WRITEF ("*");
  if (glyph->gl_comment) WRITEF(" %s\n",glyph->gl_comment)
  else WRITEF("\n")
  if (glyph->gl_label)WRITEF(glyph->gl_label);
  WRITEF("\tDEC\t%i\tGLYPH NUMBER\n",glyph->gl_number);
  WRITEF("\tDEC\t%i\tNO OF POINTS IN GLYPH INCLUDING MARGINS\n",glyph->gl_size);
  int i;
  for (i=0; i<glyph->gl_size;i++) op_point(glyph->gl_points+i);
  WRITEF("*\n");
}

void op_font( pl_font * font){
  int i;

  int size=4;
  size+=2*font->f_size;
  for (i=0; i<font->f_size;i++)size+=font->f_glyphs[i].gl_size;

  
  WRITEF (
"* %s - FONT FILE GENERATED BY FONTGEN\n"
"*\n"
"*\n"
"*       SIZE '%o (OCT)\n"
"*       SIZE  %i (DEC)\n"
"*\n*\n"
"********************************************************************\n"
"*\n*\n"
,font->f_label,size,size);

  WRITEF("\tSUBR\t%s,FNT\n",font->f_label);
  WRITEF("\tREL\t\tTHIS IS A RELOCATEABLE OBJECT.\n");
  WRITEF("\tORG\t0\n");
  WRITEF("*\n*\n"
"********************************************************************\n"
"*\n*\n");

  WRITEF ("*");
  if (font->f_comment) WRITEF(" %s\n",font->f_comment)
  else WRITEF("\n");
  WRITEF("FNT");
  // if (font->f_label)WRITEF(font->f_label);
  WRITEF("\tDEC\t%i\tVERTICAL LINE SPACING FOR FONT\n",font->f_offset);
  WRITEF("\tDEC\t%i\tY VALUE OF THE BASE LINE\n",font->f_base);
  WRITEF("\tDEC\t%i\tY VALUE OF THE TOP  LINE\n",font->f_top);
  WRITEF("\tDEC\t%i\tNUMBER OF WORDS IN FONT (FOR DYNAMIC RELOAD?)\n",font->f_size);
  WRITEF("\tDEC\t%i\tNUMBER OF GLYPHS IN FONT\n",font->f_size);
  WRITEF("*\n");
 
  for (i=0; i<font->f_size;i++){
    op_glyph(font->f_glyphs+i);
  }

  WRITEF("*\n");
  WRITEF("\tEND\n");
}
