#include <stdio.h>
#include <string.h>

#include "hw_types.h"
#include "hw_helpers.h"

char *bin2str (unsigned long value, int length)
{
    int c;
//    printf("length: %i\n", length);
    if ((length < 1) || (length > (sizeof (long) * 8)))
	return NULL;
    char *result = (char *) malloc (length + 1);
//    if (result==NULL) return NULL;
    result[length] = 0;
    result[0] = 'f';
    for (c = 0; c < length; c++)
	result[length - c - 1] = '0' + ((value >> c) & 1);
    return result;
}

void parstrip (char *data, int size)
{
    int c;
    for (c = 0; c < size; c++)
	data[c] &= 127;
}

void parset (char *data, int size)
{
    int c;
    for (c = 0; c < size; c++)
	data[c] |= 128;
}

void twistbytes (hw16 * start, int count)
{
    int c;
    char tmp;
    for (c = 0; c < count; c++) {
	tmp = start[c].bytes.high;
	start[c].bytes.high = start[c].bytes.low;
	start[c].bytes.low = tmp;
    }
}
