#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include "hw_types.h"
#include "hw_helpers.h"
#include "process.h"
#include "split.h"

#define CHAR_START 0x81
#define CHAR_END 0223


//#define STOP1 0x83
//#define STOP1 0x93
//#define STOP1 0xff


int fd=-3;
int number=0;


enum{OUTSIDE,INSIDE_ASM,INSIDE_FORT};
int state = OUTSIDE;
extern int splitnum;

#define bstart_l 1
#define bend_l   2
#define endseq_l 3
char bstart_str[bstart_l] = {CHAR_START};
char bend_str[bend_l]     = {CHAR_END,0xff};
char endseq_str[endseq_l] = {0x83,0x93,0xff};

void split_init(){
}


void split(datablock * block){
    if ((block->type==BT_STOP) && splitnum){
        char filename[200];
	number+=10;
        snprintf(filename,200,"%04i-STOP",number);
	fd=open (filename,O_WRONLY|O_CREAT|O_TRUNC,00644);
        write(fd,endseq_str,endseq_l);
	close (fd);
	return;
    }
    
    if (block->type!=BT_DATA) return;

    switch (state){
	case OUTSIDE:
	if (get_blocktype(block)==6){
		char* fn = extract_label6(block);
		char filename[200];
		number+=10;
		if (splitnum) snprintf(filename,200,"%04i-%s",number,fn);
		else snprintf(filename,200,"%s",fn);
		free(fn);
		while (filename[strlen(filename)-1]==' ')filename [strlen(filename)-1]=0;
		fd=open (filename,O_WRONLY|O_CREAT|O_TRUNC,00644);
		state=INSIDE_FORT;
		write(fd,bstart_str,bstart_l);
		write(fd,block->raw_data,(block->size)*3);
		write(fd,bend_str,bend_l);
	    }
	
	if ((get_blocktype(block)==0)&& (get_blocksubtype(block)==0)){    
		char ** labels=extract_labels0(block);
		char* fn = labels[0];
		char filename[200];
		number+=10;
		if (splitnum) snprintf(filename,200,"%04i-%s",number,fn);
		else snprintf(filename,200,"%s",fn);
		
		while (filename[strlen(filename)-1]==' ')filename [strlen(filename)-1]=0;
		fd=open (filename,O_WRONLY|O_CREAT|O_TRUNC,00644);
		dispose_labels(labels);
		
		state=INSIDE_ASM;
		write(fd,bstart_str,bstart_l);
		write(fd,block->raw_data,(block->size)*3);
		write(fd,bend_str,bend_l);
	}
	break;

	case INSIDE_ASM:
	write(fd,bstart_str,bstart_l);
	write(fd,block->raw_data,(block->size)*3);
	write(fd,bend_str,bend_l);
	if (get_blocksubtype(block)==014){
	    state=OUTSIDE;
	    close(fd);
	}
	break;
	
	case INSIDE_FORT:
	write(fd,bstart_str,bstart_l);
	write(fd,block->raw_data,(block->size)*3);
	write(fd,bend_str,bend_l);
	if ((get_blocktype(block)==3)||get_blocktype(block)==4){
	    state=OUTSIDE;
	    close(fd);
	}    
	break;
    }
}	    
